package cz.vsb.jat2018.cv3v2;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import javax.swing.JButton;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.event.ActionListener;
import java.time.LocalDate;
import java.awt.event.ActionEvent;

public class CarListWindow extends JFrame {

	private JPanel contentPane;
	private JScrollPane scrollPane;
	private JTable table;
	private CarTableModel carTableModel;
	private JPanel panel;
	private JPanel panel_1;
	private JButton btnAdd;
	private JButton btnDelete;
	private JButton btnList;
	private JButton btnIncreaseDoorCount;
	private JButton btnDecreaseDoorCount;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					CarListWindow frame = new CarListWindow();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public CarListWindow() {
		initialize();
		enableButtons(false);
	}
	private void initialize() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		contentPane.add(getScrollPane(), BorderLayout.CENTER);
		contentPane.add(getPanel(), BorderLayout.EAST);
		contentPane.add(getPanel_1(), BorderLayout.SOUTH);
	}
	private JScrollPane getScrollPane() {
		if (scrollPane == null) {
			scrollPane = new JScrollPane();
			scrollPane.setViewportView(getTable());
		}
		return scrollPane;
	}
	private JTable getTable() {
		if (table == null) {
			table = new JTable();
			carTableModel = new CarTableModel(); 
			table.setModel(carTableModel);
			table.getSelectionModel().addListSelectionListener(e -> enableButtons(getTable().getSelectedRowCount()==1));
			table.setDefaultRenderer(CarColor.class, new CarColorRenderer());
			table.setDefaultEditor(CarColor.class, new CarColorEditor());
			table.setDefaultEditor(LocalDate.class, new DateCellEditor());
		}
		return table;
	}
	
	private void enableButtons(boolean enable) {
		getBtnDelete().setEnabled(enable);
		getBtnDecreaseDoorCount().setEnabled(enable);
		getBtnIncreaseDoorCount().setEnabled(enable);
	}
	
	private JPanel getPanel() {
		if (panel == null) {
			panel = new JPanel();
			GridBagLayout gblPanel = new GridBagLayout();
			panel.setLayout(gblPanel);
			GridBagConstraints gbc_btnAdd = new GridBagConstraints();
			gbc_btnAdd.fill = GridBagConstraints.HORIZONTAL;
			gbc_btnAdd.gridwidth = 0;
			gbc_btnAdd.insets = new Insets(2, 2, 2, 2);
			panel.add(getBtnAdd(), gbc_btnAdd);
			GridBagConstraints gbc_btnDelete = new GridBagConstraints();
			gbc_btnDelete.fill = GridBagConstraints.HORIZONTAL;
			gbc_btnDelete.gridwidth = 0;
			gbc_btnDelete.insets = new Insets(2, 2, 2, 2);
			panel.add(getBtnDelete(), gbc_btnDelete);
			GridBagConstraints gbc_btnList = new GridBagConstraints();
			gbc_btnList.insets = new Insets(2, 2, 2, 2);
			gbc_btnList.anchor = GridBagConstraints.NORTH;
			gbc_btnList.fill = GridBagConstraints.HORIZONTAL;
			gbc_btnList.weighty = 1.0;
			gbc_btnList.gridwidth = 0;
			panel.add(getBtnList(), gbc_btnList);
		}
		return panel;
	}
	private JPanel getPanel_1() {
		if (panel_1 == null) {
			panel_1 = new JPanel();
			GridBagLayout gbl_panel_1 = new GridBagLayout();
			panel_1.setLayout(gbl_panel_1);
			GridBagConstraints gbc_btnIncreaseDoorCount = new GridBagConstraints();
			gbc_btnIncreaseDoorCount.insets = new Insets(2, 2, 2, 2);
			gbc_btnIncreaseDoorCount.weightx = 1.0;
			gbc_btnIncreaseDoorCount.anchor = GridBagConstraints.EAST;
			panel_1.add(getBtnIncreaseDoorCount(), gbc_btnIncreaseDoorCount);
			GridBagConstraints gbc_btnDecreaseDoorCount = new GridBagConstraints();
			gbc_btnDecreaseDoorCount.insets = new Insets(2, 2, 2, 2);
			gbc_btnDecreaseDoorCount.anchor = GridBagConstraints.NORTHWEST;
			panel_1.add(getBtnDecreaseDoorCount(), gbc_btnDecreaseDoorCount);
		}
		return panel_1;
	}
	private JButton getBtnAdd() {
		if (btnAdd == null) {
			btnAdd = new JButton("Add");
			btnAdd.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					carTableModel.addCar();
				}
			});
		}
		return btnAdd;
	}
	private JButton getBtnDelete() {
		if (btnDelete == null) {
			btnDelete = new JButton("Delete");
			btnDelete.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					carTableModel.deleteCar(getTable().getSelectedRow());
				}
			});
		}
		return btnDelete;
	}
	private JButton getBtnList() {
		if (btnList == null) {
			btnList = new JButton("List");
			btnList.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					carTableModel.list();
				}
			});
		}
		return btnList;
	}
	private JButton getBtnIncreaseDoorCount() {
		if (btnIncreaseDoorCount == null) {
			btnIncreaseDoorCount = new JButton("Increase Door Count");
			btnIncreaseDoorCount.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					carTableModel.changeDoorCount(getTable().getSelectedRow(), 1);
				}
			});
		}
		return btnIncreaseDoorCount;
	}
	private JButton getBtnDecreaseDoorCount() {
		if (btnDecreaseDoorCount == null) {
			btnDecreaseDoorCount = new JButton("Decrease Door Count");
			btnDecreaseDoorCount.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					carTableModel.changeDoorCount(getTable().getSelectedRow(), -1);
				}
			});
		}
		return btnDecreaseDoorCount;
	}
}
