package cz.vsb.jat2018.cv3v2;

import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

import javax.swing.table.AbstractTableModel;

public class CarTableModel extends AbstractTableModel{

	private List<Car> cars = new ArrayList<>();
	
	public CarTableModel() {
		cars.add(Car.createRandomCar());
		cars.add(Car.createRandomCar());
		cars.add(Car.createRandomCar());
		cars.add(Car.createRandomCar());
		cars.add(Car.createRandomCar());
		cars.add(Car.createRandomCar());
	}
	
	@Override
	public int getRowCount() {
		return cars.size();
	}

	@Override
	public int getColumnCount() {
		return 4;
	}

	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		Car car = cars.get(rowIndex);
		switch (columnIndex) {
		case 0:
			return car.getMark();
		case 1:
			return car.getColor();
		case 2:
			return car.getDoorCount();
		case 3:
			return car.getFirstDate();
		default:
			return "";
		}
	}

	@Override
	public String getColumnName(int column) {
		switch (column) {
		case 0:
			return "Car maker";
		case 1:
			return "Color";
		case 2:
			return "Door count";
		case 3:
			return "First date";
		default:
			return "";
		}
	}

	@Override
	public Class<?> getColumnClass(int columnIndex) {
		switch (columnIndex) {
		case 0:
			return String.class;
		case 1:
			return CarColor.class;
		case 2:
			return Integer.class;
		case 3:
			return LocalDate.class;
		default:
			return super.getColumnClass(columnIndex);
		}
	}

	@Override
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		return columnIndex != 2;
	}

	@Override
	public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
		Car car = cars.get(rowIndex);
		switch (columnIndex) {
		case 0:
			car.setMark(aValue.toString());
			break;
		case 1:
			car.setColor((CarColor)aValue);
			break;
		case 2:
			car.setDoorCount((Integer)aValue);
			break;
		case 3:
			car.setFirstDate((LocalDate)aValue);
			break;
		default:
			break;
		}
		fireTableRowsInserted(rowIndex, rowIndex);
	}

	public void list() {
		for (Car car : cars) {
			System.out.println(car);
		}
	}
	
	public void addCar() {
		cars.add(Car.createRandomCar());
		fireTableRowsInserted(cars.size()-1, cars.size()-1);
	}
	
	public void deleteCar(int index) {
		cars.remove(index);
		fireTableRowsDeleted(index, index);
	}
	
	public void changeDoorCount(int index, int delta) {
		Car car = cars.get(index);
		car.setDoorCount(car.getDoorCount()+delta);
		fireTableRowsUpdated(index, index);
	}
}
